% Exercise 2
% Monte Carlo Integration. Assume that we have R draws from the posterior
% of a parameter theta. Lets generate this parameter from a Normal density
% with posterior mean 1 and variance 4.
theta_mean=1;
theta_var = 4;
number_of_draws = 100000; % the number of draws we obtain will affect the precision
                        %of the approximation using Monte Carlo integration
                        
theta_post= theta_mean + sqrt(theta_var)*randn(number_of_draws,1);

% Lets estimate the expected value of the function theta^2 using MC integration
theta_sq = (theta_post).^2;
MC_integration = mean(theta_sq);

%Here is another way of doing exactly as above, but using a "for loop"

theta_sq1=0;
for i=1:number_of_draws
    theta_draw=theta_mean+ sqrt(theta_var)*randn(1,1);
    theta_sq1 = theta_sq1 + theta_draw^2;
end
theta_sq1=theta_sq1/number_of_draws;


% Now evaluate how good the result is. In order to do that, we evaluate
% E(theta)^2 using numerical integration
%Numerical integration is a method not commonly used in Bayesian
%econometrics since it only works well in very simple cases
%So I won't explain numerical integration. But in this simple example it
%can be used to get alternative way of calculating E(theta^2)
% fun, is an inline MATLAB function which is the product of the x^2 function,
% and the Normal(1,2) density function
fun = inline('(x.^2).*(0.1995*exp((-(x-1).^2)/8))');
Numerical_integration=quadl(fun,-10,10);

disp('Numerical integration')
disp(Numerical_integration)
disp('     ')
disp('Monte Carlo integration')
disp(MC_integration)
disp('Monte Carlo integration (alternative method)')
disp(theta_sq1)