% Exercise 3
%---------------------------------------------------------
% Code that calculates the posterior of an unknown 
% normal mean (variance is known). 
%---------------------------------------------------------
%First artificially generate a data set to work with
% Lets generate y from a N(ymean,sigma^2) density:   
sigma = 2;   
ymean=3.5;
% How many observations to generate???
obs = 1000; %****

% Now generate the sample y from the normal density
y = ymean + sigma*randn(obs,1);
       
% Next set values for the prior hyperparameters.
% An 'uninformative' choice would be mu = 0 and tau = 100000.
% However experiment with other values. What would happen if you
% impose mu to be much different than the true value (ymean) and with set a
% small prior variance? 
mu = -5;  % this is the prior mean              %****
tau = 1;  % this is the prior variance    %****
       
% Next work out the posterior mean and variance using formula in exercise sheet   
theta_mean = ((sigma^2 + tau^2)^(-1) )*((sigma^2)*mu + (tau^2)*mean(y));
theta_variance = ((sigma^2 + tau^2)^(-1) )*(sigma^2)*(tau^2);

%Now we can do Monte Carlo integration 
% Knowing the posterior mean and variance are enough in order to characterize 
% the posterior of the parameters, since this is a Normal density. However we can easily    
% generate samples from the posterior and plot the full density
samp_no = 100000;  % define number of samples to obtain           %**** 
theta_posterior = theta_mean + sqrt(theta_variance)*randn(samp_no,1); 
   
% Now get an idea of how your posterior looks like
figure
hist(theta_posterior,30)
title('histogram of the samples from the parameter posterior')

% You can also get samples from your prior and plot those as well   
theta_prior = mu + tau*randn(samp_no,1);
figure
hist(theta_prior,30)
title('histogram of the samples from the parameter prior')


% You can also view how close your initial guess (the prior) is
% compared to the posterior
%choose lower and upper ranges on the X-axis of the graph
glower=-10;
gupper=10;
figure
dens1=normpdf([glower:0.001:gupper],mu,tau);
dens2=normpdf([glower:0.001:gupper],theta_mean,sqrt(theta_variance));
plot([glower:0.001:gupper],dens1,'-',[glower:0.001:gupper],dens2,'--')
title('prior and posterior')

% Results for simulation exercise:
disp(['True mean of theta is ' num2str(ymean)])
disp('    ')
disp(['Average of the posterior draws of theta is  ' num2str(mean(theta_posterior))])
disp('    ')
disp(['The OLS estimate of mu is  ' num2str(mean(y))])